 <section>
    <h2 style="font-size:130%;color:#000000;">Historique(s) du Notebook</h2>
            </section>

              <!-- Discussion et textes des slides ici : https://gitlab.huma-num.fr/gt-notebook/roadmap/-/issues/17 -->

          <section>
              <!-- https://gitlab.huma-num.fr/gt-notebook/roadmap/-/issues/17-->
              <h3 style="font-size:130%;color:#000000;">Les ancêtres du Notebook</h3>
              <div class='container'>
                  <div class='col'>
                      <img src="image/Wolfram-Language-on-early-Mac.png" style="width:450px;" />
                      <p style="font-size:30%;text-align:left;">
                          Macintosh & Mathematica : <br/> https://www.wolfram.com/mathematica/scrapbook/</p>
                  </div>
                  <div class='col'>
                      <ol type="1" style="font-size:70%;text-align:left;line-height: 1.5;">
                          <li >
                              - Axiom / Scratchpad 1970
                          </li>
                          <li >
                              - MathCad 1987
                          </li>
                          <li>
                              - Mathematica 1988
                          </li>
                          <li>
                              - Maple 1989
                          </li>
                          <li>
                              - IPython 2011 (ancêtre de Jupyter)
                          </li>
                      </ol>
                </div>
              </div>
          </section>

              <!-- Discussion et textes des slides ici : https://gitlab.huma-num.fr/gt-notebook/roadmap/-/issues/11 -->
              <section>
                  <div class='child'>
                      <h3 style="font-size:130%;color:#000000;"> Principes au coeur des NB: Literate Programming (LP) </h3>
                      <p style="margin: 2;padding: 0;font-size: medium; "> <b>L'idée et la mise en oeuvre originale (1977-78) : Donal Knuth </b></p>
                      <figure class="quote" >
                          <blockquote style="font-size: 50%; text-align: left;"> Instead of imagining that our main task is to instruct a computer what to do,
                              let us concentrate rather on explaining to human beings what we want a computer to do.</blockquote>
                          <figcaption style="font-size: 30%;">—Donal Knuth <cite><a href="http://www.literateprogramming.com/">LP Website citations page</a></cite> </figcaption>
                      </figure>
                      <figure class="quote">
                          <blockquote style="font-size: 50%;text-align: left;"> The practitioner of literate programming can be regarded <strong>as an essayist</strong>, whose main concern is with exposition and excellence of style.
                        Such an author, with thesaurus in hand, chooses the names of variables carefully and explains what each variable means.
                        <br/>He or she strives for <strong>a program that is comprehensible because its concepts have been introduced in an order that is best for human understanding</strong>,
                              using a mixture of formal and informal methods that reinforce each other.
                          </blockquote>
                          <figcaption style="font-size: 30%;">—Donal Knuth <cite><a href="http://www.literateprogramming.com/">LP Website citations page</a></cite> </figcaption>
                      </blockquote>
                      </figure>
                  </div>
              </section>


              <section>
                  <h3 style="font-size:130%;color:#000000;">Un paradigme</h3>
                  <div class='parent' >
                      <div class='child'>
                      <figure class="quote">
                          <blockquote style="font-size: 30%;margin:0px;padding:5px;"> The issue of literate programming is an issue of writing a program
                                     that LIVES rather than writing a program that WORKS.</blockquote>
                          <figcaption style="font-size: 30%;">—Tim, Daly <cite><a href="http://lambda-the-ultimate.org/node/3663">Comment in 2009 on Lambda blog</a></cite> </figcaption>

                      </figure>
                          <figure class="quote">
                          <blockquote style="font-size: 30%;margin:5px;padding:5px;">
                              Literate Programming is <strong>NOT</strong> documentation[...]Literate Programming is a change in mindset
                          </blockquote>

                          <figcaption style="font-size: 30%;">—Tim, Daly <cite><a href="http://www.axiom-developer.org/axiom-website/litprog.html">Axiom Website</a></cite> </figcaption>
                      </figure>
                          <div class='container'>
                              <div class='col'>
                                  <figure class="quote">
                                      <blockquote style="font-size: 40%;text-align:left;">
                                          The first reaction is that this is a new, painful form of documentation.
                                          It is not. Documentation is a <strong>how</strong> construct. It is a way of explaining how a program works or how an application interface should be used.<br/>
                                          <br/>
                                          Literate programming is about <strong>why</strong>.[...]<br/>
                                          <br/>
                                          The <strong>why</strong> becomes important when you have to maintain and modify a program.
                                          You can perfectly understand <strong>how</strong> a subroutine, module, or class works.
                                          You can explain its input and outputs. What you don't understand is <strong>why</strong> it exists.
                                          Nobody writes that down. [...]<br/><br/>

                                          In order to do literate programming you have to change the way you think.<br/>
                                          You have to move from ideas to implementation in a way that make the story clear.
                                      </blockquote>
                                      <figcaption style="font-size: 30%;">—Tim, Daly <cite><a href="http://www.axiom-developer.org/axiom-website/litprog.html">Axiom Website</a></cite> </figcaption>
                                  </figure>
                              </div>
                              <div>
                                  <img src="image/dontdisturbprogrammers.png" style="width:450px;" />
                              </div>

                          </div>

                      </div>
                  </div>
              </section>
     <section>
         <h3 style="font-size:130%;color:#000000;">Sans Literate Programing ... </h3>
         <div class='parent'>
             <div class='child'>
                 <img src="image/LPa.png" style="width:750px;" />
             </div>
         </div>
     </section>
     <section>
         <h3 style="font-size:130%;color:#000000;">Avec Literate Programing</h3>
         <div class='parent'>
             <div class='child'>
                 <img src="image/LPb.png" style="width:950px;" />
             </div>
         </div>
     </section>
          <section>
              <h3 style="font-size:130%;color:#000000;">Le Literate Programming (LP)</h3>
              <div class='parent'>
                  <div class='child'>
                      <img src="image/LPc.png" style="width:650px;" />
                  </div>
              </div>
          </section>

              <section>
                  <h3 style="font-size:130%;color:#000000;">Traduction opérationelle ?</h3>
                  <div class='container'>
                      <div class='col'>
                          <div class="sl-block" data-block-type="text" style="text-align: left;">
                              <p style="font-size: medium;">Les trois systèmes de LP (récents) les plus connus : </p>
                              <p style="font-size: medium;">
                                  <b>Org-Mode / Org-Babel Chunk :</b> <br/>
                                  <a href="https://www.orgmode.org/manual/Working-with-Source-Code.html">[Org-Mode]</a> avec <a href="https://orgmode.org/worg/org-contrib/babel/intro.html">[Org-Babel]</a> supporte de nombreuses fonctionalités du LP<br/><br/>
                                  <b>RMarkdown Chunk :</b> <br/> Il y a <a href="https://bookdown.org/yihui/rmarkdown-cookbook/chunk-options.html">[+50 options]</a>
                                  pour les chunks en R. RMarkdown supporte une grande partie des spécificités du LP.
                                  <br/><br/>
                                  <b>Jupyter :</b><br/> Il y a de nombreux formats et conversion de format pour .ipynb, mais toutes les fonctionnalités offertes par le LP ne sont pas couvertes :
                                  Jupyter Book MD, RMarkdown, MyST, Jupytext, etc.
                              <p/>
                          </div>

                      </div>
                      <div class='col'>
                          <div class='parent'>
                              <div class="sl-block" data-block-type="code">
                                  <div class="sl-block-content notranslate" data-code-frame="none"
                                       data-code-wrap="true">
                    <pre style="font-size: 14px; line-height: 19px;">
                        <b>Web/Noweb Chunk :</b>
                        <code data-trim><script type="text/template">
                           '''<<>>= start a chunk
                                <BODY>
                                @ start a text
                            '''
                         </script></code>
                    </pre>
                                  </div>
                              </div>
                          </div>
                          <div class='parent'>
                              <div class="sl-block" data-block-type="code">
                                  <div class="sl-block-content notranslate" data-code-frame="none"
                                       data-code-wrap="true">
                    <pre style="font-size: 14px; line-height: 19px;">
                         <b>Org-mode Chunk :</b>
                        <code data-trim><script type="text/template">
                            #+NAME:  <LABEL>
                            #+BEGIN_SRC <LANGUAGE> <SWITCHES> <HEADER-ARGS>
                                <BODY>
                            #+END_SRC
                         </script></code>
                    </pre>
                                  </div>
                              </div>
                          </div>
                          <div class='parent'>
                              <div class="sl-block" data-block-type="code">
                                  <div class="sl-block-content notranslate" data-code-frame="none"
                                       data-code-wrap="true">
                    <pre style="font-size: 14px; line-height: 19px;">
                        <b>RMarkdown Chunk :</b>
                        <code data-trim><script type="text/template">
                           '''{r, label=<LABEL>, <HEADER-ARGS> }
                                <BODY>
                            '''
                         </script></code>
                    </pre>
                                  </div>
                              </div>
                          </div>
                          <div class='parent'>
                              <div class="sl-block" data-block-type="code">
                                  <div class="sl-block-content notranslate" data-code-frame="none"
                                       data-code-wrap="true">
                    <pre style="font-size: 14px; line-height: 19px;">
                        <b>Jupyter book Chunk :</b>
                        <code data-trim><script type="text/template">
                           '''{code-cell}
                           <LANGUAGE>
                               :tags: <HEADER-ARGS>
                                <BODY>
                            '''
                         </script></code>
                    </pre>
                                  </div>
                              </div>
                          </div>
                      </div>
                  </div>

              </section>

              <section data-background-color="white">
                  <h3 style="font-size:130%;color:#000000;">Réutilisabilité des chunks</h3>
                  <div class="sl-block" data-block-type="text" style="text-align: left;" >
                      <p style="font-size: medium;" >"Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.
                          Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>
                  </div>
                  <div class="sl-block" data-block-type="code"  >
                      <div class="sl-block-content notranslate" data-code-frame="none" data-code-wrap="true">
                    <pre style="font-size: 16px; line-height: 19px;">
                        <code  data-trim ><script type="text/template">
                            #+NAME: chaine_traitements
                            #+BEGIN_SRC python
                            <<traitement_1>>
                            <<traitement_2>>
                            #+END_SRC
                         </script></code>
                    </pre>
                      </div>
                  </div>
                  <div class="sl-block" data-block-type="text" style="text-align: left;" >
                      <p style="font-size: medium;" >"Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.
                          Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."</p>
                  </div>
                  <div class="sl-block" data-block-type="code"  >
                      <div class="sl-block-content notranslate" data-code-frame="none" data-code-wrap="true">
                    <pre style="font-size: 16px; line-height: 19px;">
                         <code  data-trim ><script type="text/template">
                        #+NAME: traitement_1
                        #+BEGIN_SRC python :noweb yes :results output
                        ...
                        #+END_SRC
                         </script></code>
                    </pre>
                      </div>
                  </div>
                  <div class="sl-block" data-block-type="code"  >
                      <div class="sl-block-content notranslate" data-code-frame="none" data-code-wrap="true">
                    <pre style="font-size: 16px; line-height: 19px;">
                         <code  data-trim ><script type="text/template">
                        #+NAME: traitement_2
                        #+BEGIN_SRC python :noweb yes :results output
                        ...
                        #+END_SRC
                         </script></code>
                    </pre>
                      </div>
                  </div>
              </section>

          <section data-background-color="white">
              <h3 style="font-size:130%;color:#000000;">Paramétrer les chunks</h3>
              <div class="sl-block" data-block-type="text" style="text-align: left;" >
                  <p style="font-size: medium;" >"Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.
                  Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.</p>
              </div>
              <div class="sl-block" data-block-type="code"  >
                  <div class="sl-block-content notranslate" data-code-frame="none" data-code-wrap="true">
                    <pre style="font-size: 16px; line-height: 19px;">
                        <code  data-trim >
                            #+NAME: somme
                            #+BEGIN_SRC python :var a=0 :var b=0
                            def compute_sum(a,b):
                                c = a + b
                                return c
                            return compute_sum(a,b)
                            #+END_SRC
                        </code>
                    </pre>
                  </div>
              </div>
              <div class="sl-block" data-block-type="text" style="text-align: left;" >
                  <p style="font-size: medium;" >"Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.
              Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."</p>
              </div>
              <div class="sl-block" data-block-type="code"  >
                  <div class="sl-block-content notranslate" data-code-frame="none" data-code-wrap="true">
                    <pre style="font-size: 16px; line-height: 19px;">
                         <code  data-trim ><script type="text/template">
                        #+NAME: calcul_complexe
                        #+BEGIN_SRC python :noweb yes :results output
                        a = <<somme(a=3,b=5)>>
                        print(a)
                        #+END_SRC
                         </script></code>
                    </pre>
                  </div>
              </div>
          </section>
          <section>
              <h3 style="font-size:130%;color:#000000;">Le Chunk, un objet pas si simple.</h3>
              <div class='parent'>
                  <div class='child'>
                      <img src="image/LPd.png" style="width:650px;" />
                  </div>
              </div>
          </section>



              <section data-background-color="white">
            <h3 style="font-size:130%;color:#000000;">Les Notebooks et le LP ?</h3>
              <!-- Discussion et textes des slides ici : https://gitlab.huma-num.fr/gt-notebook/roadmap/-/issues/12 -->
              <div class='container'>
                  <div class='col' >
                      <p align="center">Literate Programming</p>
                      <figure class="quote">
                      <ol type="1" style="font-size:60%;text-align:left;line-height: 1.2;">
                          <li>
                              - Paradigmatique
                          </li>
                          <li >
                              - Processus
                          </li>
                          <li >
                              - Langage et environnements agnostique
                          </li>
                      </ol>
                      </figure>
                  </div>
                  <div class='col' >
                      <p align="center">Notebooks</p>
                  <figure class="quote" >
                      <blockquote style="font-size: 40%; text-align: left;"> We define a computational notebook as a system that supports literate programming
                          using a text-based programming language (e.g., Python, R, JavaScript, or a DSL) while interweaving expository
                          text and program outputs into a single document.</blockquote>
                      <figcaption style="font-size: 30%;">—Sam Lau <cite>The Design Space of Computational Notebooks</cite> </figcaption>
                  </figure>
                  </div>
              </div>
              <div >
                  <img src="image/venn_lp_notebook.png" style="width:400px;" />
              </div>

          </section>
          <section data-background-color="white">
              <h3 style="font-size:130%;color:#000000;">HCI : 10 dimensions (au moins)</h3>
              <div >
                  <img src="image/notebookdimensions.png" style="width:650px;" />
                  <p style="margin: 0;padding: 0;font-size: small; color:grey;">S. Lau, I. Drosos, J. M. Markel and P. J. Guo, "The Design Space of Computational Notebooks: An Analysis of 60 Systems in Academia and Industry," 2020 IEEE Symposium on Visual Languages and Human-Centric Computing (VL/HCC), 2020</p>
              </div >
          </section>
          <section data-background-color="white">
              <h3 style="font-size:130%;color:#000000;"> 60 "notebooks" (et al. !?) </h3>
              <div >
                  <p style="margin: 2;padding: 0;font-size: medium; color:red;"><b>! Attention à la logique de plateforme  ... ! </b></p>
                  <img src="image/typonotebook.png" style="width:600px;margin: 0;padding: 0;" />
                  <p style="margin: 0;padding: 0;font-size: small; color:grey;"> src : S. Lau, I. Drosos, J. M. Markel and P. J. Guo, "The Design Space of Computational Notebooks: An Analysis of 60 Systems in Academia and Industry," 2020 IEEE Symposium on Visual Languages and Human-Centric Computing (VL/HCC), 2020</p>
              </div >
          </section>
              <section data-background-color="white">
                  <h3 style="font-size:130%;color:#000000;"> Dimensions ? </h3>
                  <div>
                      <ol type="1" style="font-size:60%;text-align:left;line-height: 1.5;">
                          <li>
                              - Scalabilité <p style="margin: 0;padding: 0;font-style: italic;font-size:large;color: grey;">(infrastructures, volumétrie projet, etc.)</p>
                          </li>
                          <li>
                              - Couverture du LP ? <p style="margin: 0;padding: 0;font-style: italic;font-size:large;color: grey;">(Inclusion, Paramétrisation, Options, Meta-Programming)</p>
                          </li>
                          <li>
                              - Nature et diversité des extensions <p style="margin: 0;padding: 0;font-style: italic;font-size:large;color: grey;">( HPC, Annotations, Sémantique, Versionnement, etc ?)</p>
                          </li>
                          <li>
                              - Environnements de développements
                          </li>
                          <li>
                              - Langages de programmation supportés ?
                          </li>
                          <li>
                              - Logique d'Intégration vs "pipeThinking" ?
                          </li>
                      </ol>
                     </div >
                  <div>
                      <p style="margin: 2;padding: 0;text-align:left;font-size:x-large;font-style: italic">
                          Exemple : *Org-Mode/Babel* très différent de *Jupyter* très différent de *RStudio*</p>
                  <div>
            </section>
